#pragma once

#include "v3.h"

class FrameBuffer;

class PPC {
public:
	V3 a, b, c, C;
	int w, h;
	PPC(float hfov, int _w, int _h);
	int Project(V3 p, V3 &pp);
	V3 GetVD();
	float GetFocalLength();
	void ChangeFocalLength(float scf);
	void PositionAndOrient(V3 C1, V3 L1, V3 vpv);
	void SetInterpolated(PPC *ppc0, PPC *ppc1, int stepi, int stepsN);
	void Pan(float angled);
	void Tilt(float angled);
	void Roll(float angled);
	void Visualize(PPC *ppc3, FrameBuffer *fb3, float vf, V3 colv);
	V3 UnprojectPixel(float uf, float vf, float currf);
	V3 Unproject(V3 pP);
	void SetIntrinsicsHW();
	void SetExtrinsicsHW();
};