#pragma once

#include "gui.h"
#include "framebuffer.h"
#include "ppc.h"
#include "tm.h"
#include "CGInterface.h"


class Scene {
public:

	CGInterface * cgi;
	ShaderOneInterface *soi;

	GUI *gui;
	FrameBuffer *fb, *fb3, *hwfb, *gpufb, *leftfb, *rightfb;
	PPC *ppc, *ppc3, *leftppc, *rightppc;
	Scene();
	void DBG();
	void Render();
	void Render(PPC *currPPC, FrameBuffer *currfb);
	void RenderHW();
	void RenderGPU();
	TM *tms;
	int tmsN;
	V3 L; // point light source
	float kse;
	float ka;
	float mf; // morph fraction

	ofstream *ofs;
	V3 motionColor;
	void TestDepthSensitivity();
	void AnalyzeDepthError(TM* tptm, TM* lowtm, TM* hightm, PPC* mppc, PPC* sppc, FrameBuffer* sfb);
	void AnalyzeDepthError(TM* tptm, V3 v, V3 vc, PPC* mppc, PPC* sppc, FrameBuffer* sfb);

	// panorama
	void ShowPano();

};

extern Scene *scene;